#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#define MY_INFINITY ((1UL<<(sizeof(unsigned long)*8-1))-1)
/*Global variables to hold the strings*/
char **MStrings=NULL;
unsigned int setSize;/*Input size No.of Strings*/
unsigned int MedianStarIndex=0;
unsigned long MedianStarCost=MY_INFINITY;

#define DEFAULT_READ stdin
#define DEFAULT_WRITE stdout

#ifdef die
#undef die
#endif

#define die(S) do{\
    fprintf(stderr,"FATAL:");\
    fprintf(stderr,S);\
    fprintf(stderr,"\n");\
    exit(1);}while(0);

#define NDEBUG

#ifndef NDEBUG
#define __DEBUG__
#endif


/*TODO:Need a very fast findMin*/
unsigned char _direction;
inline unsigned long getMin(unsigned long i, unsigned long j, unsigned long k){
    register unsigned long temp;
    _direction=1;
    temp = j;
    if(i<j){
        temp = i;
        _direction=0;
    }
    if(k < temp){
        temp = k;
        _direction=2;
    }
    return temp;
}
void inplaceReverse(char **s){
     int i=0;
	/*This has to be signed for condition ++i<--j to work
	 *if j=0, j-- is a positive value*/
    int j=strlen(*s)-1;
    char temp_char;
    do{
        temp_char = (*s)[i];
        (*s)[i] = (*s)[j];
        (*s)[j] = temp_char;
    }while(++i<--j);
}
/*Makesure that you zap '\0' at the end*/
/*Returns 2 char*'s (*global_alignment)[0] , (*global_alignment)[1]*/
unsigned long getEditDistance(char *s1,char *s2,char ***global_alignment){
    unsigned int M=strlen(s1);
    unsigned int N=strlen(s2);
    unsigned int i,j;
    unsigned char aux;
    unsigned long **S = (unsigned long **) malloc(sizeof(unsigned long *)*(N+1));
    char **path = (char **)malloc(sizeof(char *)*(N+1));
    unsigned long COST;
    unsigned char del_cost,ins_cost;
    char k;

     
    /*TODO:SPEED this up*/
    for(i=0;i<=N;i++){
        S[i] = (unsigned long *) malloc(sizeof(unsigned long)*(M+1));
        path[i] = (char *) malloc(sizeof(char)*(M+1));
        S[i][0] = i;
        path[i][0]=1;
    }
    for(j=0;j<=M;j++){
        S[0][j]=j;
        path[0][j]=2;
    }
	del_cost=1;ins_cost=1;
    for(i=1;i<=N;i++)
        for(j=1;j<=M;j++){
            if(s2[i-1] == s1[j-1])
                aux = 0;
            else 
                aux = 1;
            //     (i-1,j-1)[0]     (i-1,j)[1]
            //
            //     (i,j-1)[2]
            //
            S[i][j] = getMin(S[i-1][j-1]+aux,S[i-1][j]+ins_cost,S[i][j-1]+del_cost);
            path[i][j] = _direction;
        }
    COST = S[N][M];
    if(global_alignment){
     *global_alignment = (char **) malloc(sizeof(char*)*2);
     //When we do multiple alignment need to add spaces
     (*global_alignment)[0] = (char *) malloc(sizeof(char)*(M+N));
     (*global_alignment)[1] = (char *) malloc(sizeof(char)*(M+N));
     k=0;
    }
    i=N; j=M;
    while(i || j){

        //i --> s2 , j--> s1
        if(!path[i][j] /*|| path[i][j]==4*/){
            //Print the symbols
            if(global_alignment){
                (*global_alignment)[0][k]=s1[j-1];
                (*global_alignment)[1][k++]=s2[i-1];
            }
            i--;j--;
            /*Free up the space of path and S*/
            free(S[i+1]);
            free(path[i+1]);
        }
        else if(path[i][j]==1)
        { 
            if(global_alignment){ 
                (*global_alignment)[0][k]='-';
                /*
                if(!j)
                    (*global_alignment)[1][k++]='_';
                else*/
                    (*global_alignment)[1][k++]=s2[i-1]; 
            }
            i--;
            free(S[i+1]);
            free(path[i+1]);
        }
        else{
            if(global_alignment){
                /*
                if(!i)
                    (*global_alignment)[0][k]='_';
                else*/
                (*global_alignment)[0][k]=s1[j-1];
                (*global_alignment)[1][k++]='-';
            }
            j--;
        }
    }
    free(path[0]);
    free(S[0]);
    free(S);
    free(path);

    if(global_alignment){
        (*global_alignment)[0][k]='\0';
        (*global_alignment)[1][k]='\0';
    }
    /*Reverse the strings*/
    if(global_alignment){
        inplaceReverse(&((*global_alignment)[0]));
        inplaceReverse(&((*global_alignment)[1]));
    }
    return COST;
}

void findMedianStar(){
    unsigned int i,j;
    unsigned long current_min_sum=0;
    for(i=0;i<setSize;i++){
        current_min_sum=0;
        for(j=0;j<setSize;j++){
            current_min_sum += getEditDistance(MStrings[i],MStrings[j],NULL);
        }
        if(current_min_sum && current_min_sum < MedianStarCost){
            MedianStarCost = current_min_sum;
            MedianStarIndex = i;
        }
    }
	printf("best star cost: %ld\n",MedianStarCost);
#ifdef __DEBUG__
    printf("The median Star Cost is: %ld\n",MedianStarCost);
    printf("The median Star index is:%d\n",MedianStarIndex); 
#endif
}

char **aligned_strings=NULL;
char *CENTER_STAR;
void addExtraSpaces(char *center_star,char *new_center_star,unsigned int fill_len);
void printAlignment(){
	unsigned int i;
	for(i=0;i<setSize;i++){
			if(i == MedianStarIndex){
				printf("%s\n",CENTER_STAR);
			}
			else
				printf("%s\n",aligned_strings[i]);
	}
}
void doMultipleAlign(){
    unsigned int i;
	unsigned int fill_len=0;
    short int space_list[1024];
    CENTER_STAR = MStrings[MedianStarIndex];
    char **alignment_list=NULL;
    unsigned long current_score=0;
    space_list[0]=-1;

    aligned_strings = (char **)malloc(sizeof(char *)*(setSize));

    if(!aligned_strings){
        die("doMultipleAlign: Unable to allocate memory");
    }
    for(i=0;i<setSize;i++){
        if(i==MedianStarIndex) {
			aligned_strings[i] = CENTER_STAR;
			continue;
		}
        current_score += getEditDistance(CENTER_STAR,MStrings[i],&alignment_list);
        fill_len++;
        if(fill_len>1){
            addExtraSpaces(CENTER_STAR,alignment_list[0],i);
        }
        CENTER_STAR = alignment_list[0];
        aligned_strings[i] = alignment_list[1];
    }
}


void insertColumn(unsigned int k,unsigned int fill_len);
void addExtraSpaces(char *center_star,char *new_center_star,unsigned int fill_len){
    unsigned int i = strlen(new_center_star);
    unsigned int j = strlen(center_star);
    unsigned int k,k1;

    for(k=0,k1=0;k<i;k++){
        if(k1>j-1){
		insertColumn(k,fill_len);
		continue;
	    }
	    if(new_center_star[k]==center_star[k1]){
			k1++;
			continue;
		}
        if(new_center_star[k]=='-' && center_star[k1]!='-'){
	    	insertColumn(k,fill_len);
		}

    }

}
unsigned long findCost(unsigned int i, unsigned int j){
	unsigned int l = strlen(aligned_strings[i]);
	unsigned int l1 = strlen(aligned_strings[j]);
	unsigned int k;
	unsigned long cost = 0;
/*
	if(l != l1){
			die("FINAL ALIGN DONT HAVE SAME LENGTH ");
	}
*/
	for(k=0;k<l;k++){
		if(aligned_strings[i][k] != aligned_strings[j][k])
				cost++;
	}
	return cost;
}
unsigned long  getCost(){
	unsigned int i,j;
	unsigned long mcost=0;
	for(i=0;i<setSize;i++)
			for(j=i+1;j<setSize;j++)
					mcost += findCost(i,j);
	return mcost;
}
void insertColumn(unsigned int k,unsigned int fill_len){
	unsigned int i=0;
	char buffer1[1024],buffer2[1024];
	for(i=0;i<fill_len;i++){
		strncpy(buffer1,aligned_strings[i],k);
		buffer1[k]='-';
		/*VERY DANGEROUS: TODO*/
		strcpy(&buffer1[k+1],&aligned_strings[i][k]);
		/*Free up the aligned_strings*/
		free(aligned_strings[i]);
		aligned_strings[i] = (char *) malloc(sizeof(char)*(strlen(buffer1)+1));
		strcpy(aligned_strings[i],buffer1);
#ifdef __DEBUG__
		printf("ALIGNED_STRING:%s\n",aligned_strings[i]);
#endif
		
	}
}

void buildStrings(){
    char scan_buffer[1024]; /*1k buffer size :( */
    unsigned int i;
    unsigned int scan_size;

    if(fscanf(DEFAULT_READ,"%d",&setSize)!=1){
        die("Expecting a integer, unable scan the size");
    }

    i = setSize;

    MStrings = (char **) malloc(sizeof(char *)*setSize);

    if(!MStrings){
        die("MEMORY_ALLOC_PROBLEM");
    }

    while((i) && fscanf(DEFAULT_READ,"%s",scan_buffer)){
        scan_size = strlen(scan_buffer);
        MStrings[setSize-i--] = (char *) malloc(sizeof(char)*
                scan_size +1);
        if(!MStrings[setSize-(i+1)]){
            die("MEMORY_ALLOC_PROBLEM1");
        }
        if(memcpy(MStrings[setSize-(i+1)],
                    scan_buffer,scan_size)!=MStrings[setSize-(i+1)]){
            die("MEMCPY FROM GLIBC FAILED");
        }
       /*Zap a new line*/ 
       MStrings[setSize-(i+1)][scan_size+1]='\0';
    }

    if(!MStrings){
        die("Unable to scan the strings\n");
    }

#ifdef __DEBUG__
    printf("setSize: %d\n",setSize);
    for(i=0;i<setSize;i++){
        printf("__%s__\n",MStrings[i]);
    }
#endif
}
int main(){
#ifdef __DEBUG__
    char **ed_path=NULL;
#endif
    buildStrings();
#ifdef __DEBUG__
    printf("EDIT Distance is %ld\n",getEditDistance(MStrings[0],MStrings[1],&ed_path));
    printf("%s\n",ed_path[0]);
    printf("%s\n",ed_path[1]);
#endif
    findMedianStar();
    doMultipleAlign();
	printf("total cost: %ld\n",getCost());
	printAlignment();
	return 0;
}
